import processing.core.*; import pitaru.sonia_v2_9.*; import mkv.MyGUI.*; import java.io.*; import java.net.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class VoiceRecorder extends PApplet {// rob@faludi.com
// (sound meter code adapted from Amit Pitaru's Sonia examples)

   // Sonia 2.9 requires Processing 90
           // MyGUI loses features before Processing 91



Sample rawSample; // The Sonia Sample object which we'll record into
Sample[] trimmedSample;  // a sample that's just the length of what was recorded
float startTime, stopTime;  // for measuring the length of a recording
String netID, keyboardInput, message; // text input and output
int recordMode, recTimeSec;   // numbers each screen
int counter; // general purpose counter
boolean recording, playing, saving; // holds current status
char[] modeList = {
  'C', 'N', 'F', 'L', 'P', 'D'};  // so I could use letters instead of numbers to signify which screen is current
String[] filename = {
  "firstname", "lastname", "placename"};
int backgroundColor, textColor, dataBoxColor, meterColor;
boolean readyToRecord, showButtons, filesSent;
PFont theFont, titleFont;

//////////  BUTTON INITIALIZE ///////////
MyGUI guiRed, guiGreen, guiNeutral;             // easier for each color of button to have its own GUI file
MyGUIStyle styleRed, styleGreen, styleNeutral;  // easier for each color of button to have its own GUI file
MyGUIButton recButton, playButton, backButton, nextButton, clearButton; // all of the buttons
//MyGUILabel label;                             // can't use labels with Processing 90  (but need it for Sonia)
//MyGUITextInput input;                         // can't use text inputs with Processing 90
// these integers are all required for MyGUIObjects
int fontSize, theBackground, buttonFace, buttonHighlight, buttonShadow, buttonText;
int icon, face, highlight, shadow, disabled, highlightText, scrollBar;
int buttonLocY, buttonSize;  // postion and dimension attributes of the buttons

////////// NETWORK INITIALIZE ///////////
int port = 8189;
String host = "sugaki.faludi.com";

public void setup(){ 
  size(600,400);
  smooth();
  Sonia.start(this); 
  LiveInput.start();  // start the liveInput engine (see liveInput example)
  recTimeSec = 30; // number of seconds to record, determines the sample's max size. 
  rawSample = new Sample(44100*recTimeSec); // Create an empty Sample object with 44100*n-seconds frames (n seconds of data). 
  trimmedSample = new Sample[modeList.length];
  netID = "";
  keyboardInput = "";
  message = "";
  recordMode = 0;
  backgroundColor = color(255,255,255);
  textColor = color(0,0,0);
  dataBoxColor = color(200,200,200);
  meterColor = backgroundColor;
  theFont = loadFont("Futura-Medium-48.vlw"); 
  titleFont = loadFont("BertramLET-48.vlw");
  textFont(theFont);

  //////////  BUTTON SETUP ///////////
  fontSize = 14;
  buttonLocY = 300;  // location for all the buttons
  buttonSize = 60;
  theBackground = color(150,0,150);      // ??? this is the button background, but I've never seen it displayed
  buttonFace =  color(225,0,0);       // color of the button
  buttonHighlight = color(225,0,0);   // ring around the button that stays after clicking on it
  buttonShadow = color(20,20,20);       // a border around the outside of the button
  buttonText = color(0,0,0);          // color of the text on the button
  icon = color(0,0,0);
  face = color(150,150,150);
  highlight = color(225,0,0);        // color when button is depressed (or hovered after pressing for some reason)
  shadow = color(150,150,150);
  disabled = color(30,30,30);        // color when button is disabled
  highlightText = color(150,150,150);
  scrollBar = color(150,150,150);

  styleRed = new MyGUIStyle(this, theFont,  fontSize,  theBackground,  buttonFace,  buttonHighlight,  buttonShadow,
  buttonText, icon, face,  highlight,  shadow,  disabled,  highlightText,  scrollBar);

  buttonFace =  color(0,225,0);
  buttonHighlight = color(0,225,0);
  highlight = color(0,225,0);
  styleGreen = new MyGUIStyle(this, theFont,  fontSize,  theBackground,  buttonFace,  buttonHighlight,  buttonShadow,
  buttonText, icon, face,  highlight,  shadow,  disabled,  highlightText,  scrollBar);

  buttonFace =  color(225,225,225);
  buttonHighlight = color(225,225,225);
  highlight = color(225,225,225);
  styleNeutral = new MyGUIStyle(this, theFont,  fontSize,  theBackground,  buttonFace,  buttonHighlight,  buttonShadow,
  buttonText, icon, face,  highlight,  shadow,  disabled,  highlightText,  scrollBar);

  guiRed = new MyGUI(this, styleRed);
  guiGreen = new MyGUI(this, styleGreen);
  guiNeutral = new MyGUI(this, styleNeutral);
  recButton = new MyGUIButton(this,width/5*3,buttonLocY,"Record",buttonSize,buttonSize);
  playButton = new MyGUIButton(this,width/5*2,buttonLocY,"Play",buttonSize,buttonSize);
  backButton = new MyGUIButton(this,width/5*1,buttonLocY,"Back",buttonSize,buttonSize);
  nextButton = new MyGUIButton(this,width/5*4,buttonLocY,"Next",buttonSize,buttonSize);
  clearButton = new MyGUIButton(this,width/5*1,buttonLocY,"Clear",buttonSize,buttonSize);
  recButton.setActionCommand("Record");
  playButton.setActionCommand("Play");
  backButton.setActionCommand("Back");
  nextButton.setActionCommand("Next");
  clearButton.setActionCommand("Clear");
  playButton._disabled = true;
  backButton._disabled = false;
  nextButton._disabled = true;
  guiRed.add(recButton);
  guiGreen.add(playButton);
  guiNeutral.add(backButton);
  guiNeutral.add(nextButton);
  guiNeutral.add(clearButton);

} 


public void draw(){
  background(backgroundColor);
  fill(25,25,150);
  stroke(textColor);
    textFont(titleFont);
  textSize(60);
  textAlign(CENTER);
  text("Voice Recorder",width/2,height/6);
    textFont(theFont);
  textSize(24);
  fill(textColor);
  text(message,width/2,height/20*9);
  getMeterLevel();
  recordModeSelect();
} 

public void mousePressed() {
  // handle the first click that gives the applet focus, after which do nothing
  if (modeList[recordMode] == 'C') {
    recordMode++;
  }
}

public void startRecording(){ 
  delay(200);                  // slight delay so that sound of mouse is not recorded
  meterColor = color(150,0,0);
  LiveInput.startRec(rawSample); // Record LiveInput data into the Sample object. 
  startTime = millis();          // note the time that recording started
} 

public void stopRecording(){ 
  meterColor = backgroundColor;
  LiveInput.stopRec(rawSample);
  stopTime = millis();
  float recTime = (stopTime - startTime);
  int trimmedFrames = PApplet.toInt(44100*(recTime/1000)-1000);
  trimmedSample[recordMode] = new Sample(trimmedFrames);
  float[] dataArray; 
  dataArray = new float[trimmedFrames];
  rawSample.read(dataArray, 0, 0, trimmedFrames);
  trimmedSample[recordMode].write(dataArray);
} 

public void startPlay() {
  meterColor = color(0,150,0);
  trimmedSample[recordMode].play();
}

public void stopPlay() {
  meterColor = backgroundColor;
  trimmedSample[recordMode].stop();
}


// ACCEPT KEYBOARD INPUT
public void keyPressed() {
  if(modeList[recordMode] == 'N') {     // if we are currently accepting keyboard input
    if (key == ENTER && keyboardInput.length() >= 3) {
    netID = keyboardInput;
    recordMode++;
    }
    if (key != CODED && key != ENTER) {      // (the docs say that the enter key is coded, but it's not)
      if (key == BACKSPACE && keyboardInput.length() > 0) {       // handle deleting text
        keyboardInput = keyboardInput.substring(0,keyboardInput.length()-1); // only delete text if it exists
      }
      else {                     // add each keypress to the previous ones
        keyboardInput = keyboardInput+key;
        netID = "";  // clear the previous keyword
      }
    }
  }
}


public void showButtons(boolean showButtons) {
  if(showButtons) {
    clearButton._visible=false;
    backButton._visible=true;
    playButton._visible=true;
    recButton._visible=true;
    nextButton._visible=true;
  }
  else {
    clearButton._visible=false;
    backButton._visible=false;
    playButton._visible=false;
    recButton._visible=false;
    nextButton._visible=false;
  }
}



public void saveFiles() {
  for( int i=2; i<trimmedSample.length-1; i++) {
    trimmedSample[i].saveFile(netID+"-"+filename[i-2]);
    println("Saved: "+netID+"-"+filename[i-2]);
  }
}


public void stop(){ 
  Sonia.stop(); 
  super.stop(); 
} 

public void actionPerformed(ActionEvent e) {

  if(e.getActionCommand().equals("Record")) {
    recording = !recording;
    if(recording) {
      recButton._text = "Stop";
      backButton._disabled = true;
      playButton._disabled = true;
      nextButton._disabled = true;
      startRecording();
    } 
    else {
      recButton._text = "Record";
      backButton._disabled = false;
      playButton._disabled = false;
      nextButton._disabled = false;
      stopRecording();
    }
  }

  if(e.getActionCommand().equals("Play")) {
    playing = !playing;
    if(playing) {
      playButton._text = "Stop";
      recButton._disabled = true;
      startPlay();
    } 
    else {
      playButton._text = "Play";
      recButton._disabled = false;
      stopPlay();
    }
  }

  if(e.getActionCommand().equals("Back")) {
    if(playing) {
      playing = false;
      playButton._text = "Play";
      recButton._disabled = false;
      stopPlay();
    } 
    if (recordMode>0) {           // don't underrun mode list (this should never happen)
      recordMode--;
    }
  }


  if(e.getActionCommand().equals("Next")) {
    if(playing) {
      playing = false;
      playButton._text = "Play";
      recButton._disabled = false;
      stopPlay();
    } 

    if (modeList[recordMode] == 'N') {    // accept the text string in Net ID Mode
      netID = keyboardInput;
    }

    if (modeList[recordMode] == 'P') {    // accept the text string in Net ID Mode
    message = "Saving Files...";
      saving = true;
    }

    if (recordMode<modeList.length-1) {           // don't overrun mode list
      recordMode++;
      backButton._disabled = true;
      playButton._disabled = true;
      recButton._disabled = true;
      nextButton._disabled = true;               // prevent these buttons from being hit twice
    }
    else {
      recordMode=0;                              // start over instead
      for(int i = 0; i < trimmedSample.length; i++) {
        trimmedSample[i] = null;
        keyboardInput="";
      }
    }
  }

  if(e.getActionCommand().equals("Clear")) {
    keyboardInput ="";
  }
}

public void getMeterLevel() {
  //by Amit Pitaru
  float meterDataLeft = LiveInput.getLevel();
  float meterDataRight = LiveInput.getLevel();

  // draw a volume-meter for each channel.
  fill(meterColor);
  stroke(meterColor);
  float left = meterDataLeft*height/8;
  float right = meterDataRight*height/8; 

  rectMode(CORNER);
  rect(0, height, width/2 , left*-1);
  rect(width/2 , height, width, right*-1);
}

public void recordModeSelect() {
  backButton._disabled = false;
  // stop playback at the end of a sound
  if(trimmedSample[recordMode]!=null && !trimmedSample[recordMode].isPlaying() && playButton._text.equals("Stop") ){ 
    playing = false;
    meterColor = backgroundColor;
    playButton._text = "Play";
    recButton._disabled = false;
  }
  // stop recording at the end of the max sample size
  if(recording && ( (millis() - startTime) >= (recTimeSec)*1000)) { 
    recording=false;
    recButton._text = "Record";
    backButton._disabled = false;
    playButton._disabled = false;
    nextButton._disabled = false;
    stopRecording();
  }

  if (trimmedSample[recordMode]==null && !recording) {  // if this mode is not yet recorded and we're not recording
    backButton._disabled = false;
    nextButton._disabled = true;
    playButton._disabled = true;
    recButton._disabled = false;
  }
  else if (recording) {                  // if we are currently recording
    backButton._disabled = true;
    nextButton._disabled = true;
    playButton._disabled = true;
    recButton._disabled = false;
  }
  else if (playing) {                  // if we are currently playing
    backButton._disabled = false;
    nextButton._disabled = false;
    playButton._disabled = false;
    recButton._disabled = true;
  }
  else {
    backButton._disabled = false;
    nextButton._disabled = false;
    playButton._disabled = false;
    recButton._disabled = false;
  }

  switch(modeList[recordMode]) {
  case 'C':
    message = "Click to Begin";
    showButtons(false);
    recButton._text = "Record";
    playButton._text = "Play";
    backButton._text = "Back";
    nextButton._text = "Next";
    break;
  case 'N':
    message = "1. Type your Net ID";
    fill(dataBoxColor);
    stroke(dataBoxColor);
    //rectMode(CENTER);
    //rect(width/2,height/2-10,width/3,50);
    line(width/3, height/12*7,width/3*2,height/12*7);
    fill(textColor);
    textSize(30);
    text(keyboardInput,width/2,height/12*7-3);
    showButtons(false);
    clearButton._visible=true;
    clearButton._disabled=false;
    nextButton._visible=true;
    nextButton._disabled = true;
    if (keyboardInput.length() >= 3) {
      nextButton._disabled = false;
    }
    nextButton._text = "Next";
    break;
  case 'F':
    message = "2. Record your first name";
    showButtons(true);
    nextButton._text = "Next";
    backButton._text = "Back";
    break;
  case 'L':
    message = "3. Record your last name";
    showButtons(true);
    nextButton._text = "Next";
    break;
  case 'P':
    message = "4. Record where you are from\n(a geographic place name)";
    showButtons(true);
    nextButton._text = "Finish";
    break;
  case 'D':
    nextButton._disabled = true;
    if(saving) {
      message = "Saving Files...";
      backButton._disabled = true;
      playButton._disabled = true;
      recButton._disabled = true;
      nextButton._disabled = true;
    } 
    else {
      nextButton._text = "Restart";
      playButton._disabled = true;
      recButton._disabled = true;
      backButton._disabled = false;
      nextButton._disabled = false;
      if (filesSent) {
        message = "Thanks. You're Done!"; 
      }
      else {
        message = "Couldn't Save Files. Please Try Again Later";
        backButton._disabled = true;
        nextButton._disabled = true;
      }

    }
    showButtons(true);
    break;
  }
  if (saving) {       // waits one frame before saving to enable drawing text message
    counter++; 
    if(counter > 1) {
      saving = false;
      saveFiles();
      //sendFiles();
      counter = 0;
    }
  }
}

public void sendFiles() {

  for( int i=2; i<trimmedSample.length-1; i++) {       // for each Sample in array
    float[] data;                                      // declare a data variable
    data = new float[trimmedSample[i].getNumFrames()]; // creates a new array the length of the sample 
    trimmedSample[i].read(data);                       // read the Sample into data

      try {
      Socket s;

      s = new Socket(host, port);

      ObjectOutputStream oos = new ObjectOutputStream(s.getOutputStream());

      oos.writeObject(netID+filename[i-2]);
      oos.writeInt(data.length);
      oos.writeObject(data);
      println("Client: sent data for "+netID+"-"+filename[i-2]+" to the server");
      filesSent = true;
      oos.close();
      s.close();
    }
    catch (Exception e) {
      e.printStackTrace();
      filesSent = false;
      println("Unable to send: "+netID+"-"+filename[i-2]+" to the server");
    }
  }
}
static public void main(String args[]) {   PApplet.main(new String[] { "VoiceRecorder" });}}